{
  Ŀ
           CONVERT PROGRAM (C) 1995 Bright Mind Software Inc.           
                    Written by Konstantin Gredeskoul.                   
                                                                        
                Programming Environment: Turbo Pascal 6.0               
                              Version: 2.6                              
                       Last updated: 27 March 1995                      
                                                                        
        Contact internet address: <kig@brain.physics.swin.oz.au>        
          Home page on WWW: http://www.maths.monash.edu.au/~kig         
  

     This is the source code of the program. You are free to use it as you
     wish, change it, flip it, rotate it, swap it, eat it, chew it, ....
     It contains not much comments unfortunately, but I don't have a time
     for these. Please contact me should you experience any problems with
     this code. Please, feel free to send me your admirations and
     appreciations that you may feel while dealing with my algorithms :-)
     I will be happy to reply you! Have fun!

     Future possible improvements:
            - can make not only one-to-one, eg. char. equations of the
              form w=ch could also be allowed
            - user defined offchar (which is fixed at "~" in this version)

     FTP: you'll probably find the LATEST version of this program
          at brain.physics.swin.oz.au (136.186.27.10) logging in as
          anonymous ftp, in subdirectory /pub/kig/msdos/convert.zip
}

Program convert;
uses crt;
const
     sepchar   = '=';    {Character separating left and right part of eqn}
     remchar   = '#';    {Remark char.}
     comchar   = '/';    {Command line char.}
     offchar   = '~';    {Character that turns conversion on/off}
     absbound  = 255;    {Maximum number of char eqations allowed}
     tempfile  = 'TEMPFILE.TXT';  {Default destination file    }
                                  {if destination is not given }
var
     codes       : array[1..2,1..absbound] of char;      {Stores code table}
     codesbound  : integer;               {Dynamic top bound of codes array}
     ERROR       : string;                {Used in Abort procedure}
     IO          : word;                  {Used in Abort procedure}
     dummy       : integer;               {Used in VAL function}

{
  Here we just insert file that contains procedures and functions
  similar to those in Visual Basic. They, of course, not completely
  compatible, but to some extent...
}
{$I VB.PAS}

{
  Here we insert module TRANSLIT.PAS, which makes a transliteration from
  the text in Latin characters like "vot etot" to a text like " "
  - written in real Cyrillic in Alternative encoding for MS-Dos.
  The program is absolutely different from one-to-one converter, and
  so is implemented into a separate moduile.
}
{$I TRANSLIT.PAS}

Procedure ReadCodes (codefile:string);

{   Codes            array of characters.
                     codes(1,*) contains left part of conversion table,
                     codes(2,*) contains right side.}

var
    i,k,l,j          :integer;
    start,mode       :boolean;
    inpfile          :text;
    newline          :string;
    flag             :char;

begin
    if Pos('.', codefile) = 0 then codefile := codefile + '.COD';
    write('  Reading code table from file ' + ucase(codefile));
    mode  := false;
    start := false;
    i := 0;

    for i:=1 to absbound do codes[1,i]:=' ';
    for i:=1 to absbound do codes[2,i]:=' ';
    codesbound:=0;
{$I-}
    assign(inpfile, codefile);
    reset(inpfile);
    IO:=IOResult;
    if IO<>0 then abort('',IO);

    while not eof(inpfile) do begin
        readln(inpfile, NewLine);

        l := length(NewLine);
        k := pos(sepchar,NewLine);

        flag := NewLine[1];

        case flag of
            ComChar : begin
                      if pos('ASCII',NewLine)>0 then mode := true;
                      if pos('CHARS',NewLine)>0 then mode := false;
                      if pos('BEGIN',NewLine)>0 then start:= true;
                      if pos('ENDOF',NewLine)=1 then begin
                         start:= false;
                         close (inpfile);
                         gotoxy(61,wherey);writeln('(OK)');
                         exit;
                      end;
                      end;
            remchar : begin
                      end
            else
            if (l <> 0) and (k <> 0) and (start) then begin
                inc(codesbound);
                if mode then begin
                    {ASCII mode}
                    val(left(NewLine, k-1),j,dummy);
                    codes[1, codesbound] := chr(j);
                    val(mid(NewLine, k+1),j,dummy);
                    codes[2, codesbound] := chr(j);
                    end
                else begin
                    {CHARS mode}
                    codes[1, codesbound] := NewLine[1];
                    codes[2, codesbound] := NewLine[3];
                end
            end;
        end; {case}
    end; {while}
    close (inpfile);
    gotoxy(61,wherey);writeln( ' (OK)');
end; {ReadCodes}

Procedure transform(where,source,dest:string);
var
    F,T,bound       :integer;
    heapsize,i,k    :integer;
    temp,last       :integer;
    inpstring       :string;
    inpchar,outchar :char;
    response        :char;
    sf,df           :text;
    sbf             :file of byte;
    dotrans         :boolean;
    leng,j          :longint;
begin
    write( '  Testing for command line parameters');
    if (ucase(where) = 'FROM') then begin
        F := 2;
        T := 1;
    end
    else if ucase(where) ='TO' then begin
        F := 1;
        T := 2;
    end
    else Abort('Expected either ''from'' or ''to'' argument.',0);

    gotoxy(61,wherey);writeln( ' (OK)');

    {Read by 10 Kb at a time}
    heapsize := 10000;
    dotrans := true;
    bound := codesbound;

    write( '  Reading data from ' + ucase(source));
{$I-}
    assign(sbf,source);
    reset(sbf);
    IO:=IOResult;
    if IO<>0 then abort('',IO);
    leng := filesize(sbf);
    close(sbf);

    assign(sf,source);
    reset(sf);
    IO:=IOResult;
    if IO<>0 then abort('',IO);
    gotoxy(61,wherey);writeln( ' (OK)');

    write( '  Source file size is ' ,leng, ' bytes');
    gotoxy(61,wherey);writeln( ' (OK)');

    if dest = '' then dest := tempfile;
    write( '  Writing to ' + ucase(dest));

    assign(df,dest);
    rewrite(df);
    IO:=IOResult;
    if IO<>0 then abort('',IO);
    gotoxy(61,wherey);writeln( ' (OK)');

    write( '  In progress',chr(13));
    j := 1;
    temp:=0;
    last:=0;
    while not eof(sf) do begin
        Read(sf,inpchar);
        inc(j);
        temp := trunc((j/leng)*100);
        if (temp <> last) and ((temp mod 5)=0) then begin
           gotoxy(61,wherey);
           write( '(', temp, '%) ');
           last := temp;
        end;
        if InpChar = OffChar then DoTrans := (NOT DoTrans)
        else begin
            OutChar := InpChar;
            if DoTrans then begin
               i:=0;
               repeat
                  inc(i)
               until (i>Bound) or (codes[F, i] = InpChar);
               if i<=Bound then OutChar := codes[T, i];
            end;
            if keypressed then begin
               Response := readkey;
               if response <> '' then if ord(response) = 27 then Abort('User abort',0);
            end;
            write(df, OutChar);
        end
    end; {while}
    writeln;
    write( '  Closing files.....');
    close(df);
    IO:=IOResult;
    if IO<>0 then abort('',IO);
    close(sf);
    IO:=IOResult;
    if IO<>0 then abort('',IO);
    gotoxy(61,wherey);writeln( ' (OK)');
end; {transform}

begin
{$I-}
    writeln('ķ');
    writeln(' Universal Conversion Utility v2.6    (C) 1995 Konstantin Gredeskoul ');
    writeln(' Melbourne, Australia.                                    March 1995 ');
    writeln('Ķ');
    writeln(' This program is free. Any comments to <kig@brain.physics.swin.oz.au>');
    writeln('Ľ');

    if ParamCount > 2 then begin
        { OK here, we got enough arguments, we can try to transform...}
        writeln('ķ');
        writeln(' Procedure                                                 Result     ');
        writeln('Ľ');

        ReadCodes(ParamStr(2));
        Transform(paramstr(1),paramstr(3),paramstr(4));
        writeln('  Transformation complete and successful.');
        end
    else if ParamCount>0 then begin
        { enough arguments for transliterate only }
        writeln('ķ');
        writeln(' Procedure                                                 Result     ');
        writeln('Ľ');

        Transliterate(paramstr(1),paramstr(2))
        end
    else begin
        { Not enough arguments given - stop.}
        writeln('ķ');
        writeln(' USAGE 1 -> convert <from|to> <code file> <source file> [dest file]  ');
        writeln(' EXAMPLE -> convert from koi8 mytext.txt mytext1.txt                 ');
        writeln(' NOTE ----> if destfile is omitted, then TEMPFILE.TXT is used.       ');
        writeln('Ķ');
        writeln(' USAGE 2 -> convert <source file> [dest file]                        ');
        writeln(' NOTE ----> this syntax calls transliteration program.               ');
        writeln(' NOTE ----> if destfile is omitted, then TEMPFILE.TXT is used.       ');
        writeln('Ķ');
        writeln(' Abort: Not enough arguments for either type of conversion.          ');
        writeln('Ľ');
        beep;
    end;
{$I+}
end.

