{This sub-module contains following procedures/functions which are
 partially compatible with those in Microsoft Visual Basic:

 f - function
 p - procedure

      Name     Type       Description:
      -------------------------------------------
      Beep       p        SOUND (just a beep)
      lcase      f        LOWER CASE of a string
      ucase      f        UPPER CASE of a string
      abort      p*       ABORT AND SHOW MESSAGE
      min        f*       MINIMUM of two numbers
      max        f*       MAXIMUM of two numbers
      left       f        LEFT n chars of a string
      mid        f        RIGHT chars of a string 
                          starting from a position n

 * - nothing to do with Visual Basic.
}

Procedure Beep;
begin
     sound(880);delay(50);nosound;
end;

Function lcase(inp:string):string;
var
     k,l,m:integer;
     out:string;
begin
     l:=length(inp);
     out:='';
     for k:=1 to l do begin
         m:=ord(inp[k]);
         if (m > 64) and (m < 91) then out:=out+chr(m+32)
         else out:=out+inp[k];
     end;
     lcase:=out;
end;

Function ucase(inp:string):string;
var
     k,l,m:integer;
     out:string;
begin
     l:=length(inp);
     out:='';
     for k:=1 to l do begin
         m:=ord(inp[k]);
         if (m > 96) and (m < 123) then out:=out+chr(m-32)
         else out:=out+inp[k];
     end;
     ucase:=out;
end;

Procedure Abort(reason:string;code:word);
begin
     gotoxy(61,wherey);writeln( ' (--)');
     If reason='' then
        case code of
           2: reason:='File not found.';
           3: reason:='Path not found.';
           5: reason:='Access denied.';
           6: reason:='Invalid handle.';
           8: reason:='Not enough memory.';
          10: reason:='Invalid environment.';
          11: reason:='Invalid format.';
          18: reason:='No more files.';
         else reason:='Unspecified error.';
        end;
     beep;
     writeln('  Abort: ',reason);
     halt;
end;
    
Function min(a,b:longint):longint;
begin
    min := b;
    if a < b then min := a;
end;

Function max(a,b:longint):longint;
begin
    max := b;
    if a > b then max := a;
end;

Function left(inp:string; n:integer):string;
var
     k,l,m:integer;
     out:string;
begin
     out:='';
     l:=length(inp);
     if (l=0) or (n<1) then out:=''
     else if n>=l then out:=inp
     else for k:=1 to n do out:=out+inp[k];
     left:=out;
end;

Function mid(inp:string; n:integer):string;
var
     k,l,m:integer;
     out:string;
begin
     out:='';
     l:=length(inp);
     if (l=0) or (n>=l) then out:=''
     else if n<1 then out:=inp
     else for k:=n to l do out:=out+inp[k];
     mid:=out;
end;
